﻿Enumeration
  #txtKmStand
  #txtSpeicher
  #edtKmStand
  #BtnOpenFileDialog
  #BtnChangeKm
  #edtSpeicher
EndEnumeration

Declare.i GetKmFromFile(FileNameAndPath.s, Array Speicher.u(1))
Declare  ChangeKmStand(KmStand.i, Array Speicher.u(1))
Declare.i GetKmFromSpeicher(Array Speicher.u(1))
Declare.u SwapBytesInWord(wert.u)
Dim Speicher.u(7)

hWindowMain.i = OpenWindow(#PB_Any, 0, 0, 320, 100, "Rechner", #PB_Window_MinimizeGadget | #PB_Window_ScreenCentered)
If hWindowMain
  TextGadget(#txtKmStand, 10, 10, 50, 20, "Km Stand")
  StringGadget(#edtKmStand, 60, 10, 60, 20, "1", #PB_String_Numeric)
  ButtonGadget(#BtnOpenFileDialog, 130, 10, 60, 20, "Öffne...")
  ButtonGadget(#BtnChangeKm, 200, 10, 110, 20, "ändere Km Stand")
  TextGadget(#txtSpeicher, 10, 40, 50, 20, "Speicher")
  StringGadget(#edtSpeicher, 60, 40, 250, 20, "FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF", #PB_String_ReadOnly)
  Define main_quit = #False
  Repeat
    Define window_event.i = WaitWindowEvent(100)
    Select window_event
      Case #PB_Event_Gadget
        Select EventGadget()
        Case #BtnOpenFileDialog
          Define ofd.s = OpenFileRequester("Öffne", "", "Bin (*.bin)|*.bin", 1)
          If ofd <> #Null$
            SetGadgetText(#edtKmStand, Str(GetKmFromFile(ofd, Speicher())))
            Define Text.s = #Null$
            For a.i = 0 To 7
              Text + RSet(Hex(Speicher(a)), 4, "0") + " "
            Next a
            SetGadgetText(#edtSpeicher, Text)
          EndIf
        Case #BtnChangeKm
          Define km.i = Val(GetGadgetText(#edtKmStand))
          If km <= 1000000
            ChangeKmStand(km, Speicher())
            Define Text.s = #Null$
            For a.i = 0 To 7
              Text + RSet(Hex(SwapBytesInWord(Speicher(a))), 4, "0") + " "
            Next a
            SetGadgetText(#edtSpeicher, Text)
            SetGadgetText(#edtKmStand, Str(GetKmFromSpeicher(Speicher())))
          Else
            MessageRequester("Fehler", "Km Stand muss kleiner gleich 1.000.000 km", #PB_MessageRequester_Error | #PB_MessageRequester_Ok)
          EndIf
        EndSelect
      Case #PB_Event_CloseWindow
        main_quit = #True
      Default
        Delay(10)
    EndSelect
  Until main_quit
  CloseWindow(hWindowMain)
EndIf
End

Procedure.i GetKmFromFile(FileNameAndPath.s, Array Speicher.u(1))
  Protected hFile.i = ReadFile(#PB_Any, FileNameAndPath)
  If hFile
    FileSeek(hFile, $1F0, #PB_Absolute)
    Protected KmStand.i = 0
    For a.i = 0 To 7
      wert.u = ReadUnicodeCharacter(hFile)
      Speicher(a) = SwapBytesInWord(wert)
      KmStand + ($FFFF - wert)
    Next a
    CloseFile(hFile)
  EndIf
  ProcedureReturn KmStand * 2 + 1
EndProcedure

Procedure.i GetKmFromSpeicher(Array Speicher.u(1))
  Protected KmStand.i = 0
  For a.i = 0 To 7
    Debug speicher(a)
    KmStand + ($FFFF - Speicher(a))
    Debug KmStand
  Next a
  ProcedureReturn KmStand * 2 + 1
EndProcedure

Procedure ChangeKmStand(KmStand.i, Array Speicher.u(1))
  Protected grundwert.i = KmStand / 16
  Protected rest.i = (KmStand % 16) / 2
  Protected wert.u
  For a.i = 0 To 7
    If rest
      wert = $FFFF - grundwert - 1
      rest - 1
    Else
      wert = $FFFF - grundwert
    EndIf
    Speicher(a) = wert
  Next a
EndProcedure

Procedure.u SwapBytesInWord(wert.u)
  ProcedureReturn ((wert >> 8) & $FF) | ((wert << 8) & $FF00)
EndProcedure

; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 51
; FirstLine = 51
; Folding = -
; EnableXP
; Executable = Rechner_x64.exe